/*
 *  TOPPERS/SSP Kernel
 *      Smallest Set Profile Kernel
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2010 by Naoki Saito
 *             Nagoya Municipal Industrial Research Institute, JAPAN
 *  Copyright (C) 2010 by Meika Sugimoto
 * 
 *  嵭Ԥϡʲ (1)(4) ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣѡ
 *  ۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ǤǺۤˤϡۤȼɥȡѼԥ
 *      ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ̵
 *      ڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ǤʤǺۤˤϡΤ줫ξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡޤ
 *      ܥեȥΥ桼ޤϥɥ桼Τʤͳ˴
 *      ᤫ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪФ
 *  ŬޤơʤݾڤԤʤޤܥեȥ
 *  ˤľŪޤϴŪʤ»˴ؤƤ⡤Ǥ
 *  ʤ
 * 
 */

#include "kernel_impl.h"
#include "task.h"

/*
 *  ȥ졼ޥΥǥե
 */

#ifndef LOG_DSP_ENTER
	#define LOG_DSP_ENTER(tskidx)
#endif /* LOG_DSP_ENTER */

#ifndef LOG_DSP_LEAVE
	#define LOG_DSP_LEAVE(tskidx)
#endif /* LOG_DSP_ENTER */


extern const intptr_t	tinib_exinf[];			/* γĥ */
extern const TASK    	tinib_task[];			/* εư */
extern const uint_t  	tinib_epriority[];		/* μ¹Իͥ١ɽ */


#ifdef TOPPERS_tskini

/*
 * ¹Ծ֥εưͥ
 */
uint_t runtsk_ipri;

/*
 *  ǥ塼ΤΥӥåȥޥå
 */
volatile uint_t	ready_primap;

/*
 *  ǥѥåư׵ե饰
 */
bool_t	reqflg;

/*
 *  ǥѥåػ߾
 */
bool_t	disdsp;

/*
 *  read_primapν
 */
extern const uint_t init_rdypmap;

#endif /* TOPPERS_tskini */

#ifdef TOPPERS_get_ipri_self

/*
 *  ID鵯ưͥ٤ФΥޥ
 */
uint_t
get_ipri_self(ID tskid)
{
	uint_t inipri;
	
	if(tskid != TSK_SELF)
	{
		inipri = (uint_t)((tskid) - TMIN_TSKID);
	}
	else
	{
		inipri = runtsk_ipri;
	}
	return inipri;
}

#endif /* TOPPERS_get_ipri_self */

#ifdef TOPPERS_get_ipri

uint_t
get_ipri(ID tskid)
{
	return (uint_t)(tskid - TMIN_TSKID);
}

#endif /* TOPPERS_get_ipri */

/*
 *  ӥåȥޥåץؿ
 *
 *  bitmap1ΥӥåȤ⡤ǤⲼ̡ʱˤΤΤ򥵡Υӥ
 *  ֹ֤ӥåֹϡǲ̥ӥåȤ0Ȥ롥bitmap0
 *  ƤϤʤʤδؿǤϡbitmap8ӥåȤǤ뤳Ȥꤷ
 *  uint8_tȤƤ롥
 *
 *  ӥåȥ̿ĥץåǤϡӥåȥ̿Ȥ褦
 *  ľΨɤ礬롥Τ褦ʾˤϡå
 *  ¸ǥӥåȥ̿Ȥäbitmap_search
 *  OMIT_BITMAP_SEARCHޥФ褤ޤӥåȥ̿
 *  դʤɤͳͥ٤ȥӥåȤȤбѹ
 *  ϡPRIMAP_BITޥФ褤
 *
 *  ޤɸ饤֥ffsʤ顤Τ褦ɸ饤
 *  ȤäΨɤǽ⤢롥
 *		#define	bitmap_search(bitmap) (ffs(bitmap) - 1)
 */
#ifndef PRIMAP_BIT
#define	PRIMAP_BIT(pri)		(1U << (pri))
#endif /* PRIMAP_BIT */

#ifndef OMIT_BITMAP_SEARCH

static const uint8_t bitmap_search_table[] = { 0U, 1U, 0U, 2U, 0U, 1U, 0U,
												3U, 0U, 1U, 0U, 2U, 0U, 1U, 0U };

Inline uint_t
bitmap_search(uint_t bitmap)
{
	uint_t	n = 0U;

	if ((bitmap & 0x0fU) == 0U) {
		bitmap >>= 4U;
		n += 4U;
	}
	return (n + bitmap_search_table[(bitmap & 0x0fU) - 1U]);
}

#endif /* OMIT_BITMAP_SEARCH */

/*
 *  ͥ٥ӥåȥޥåפΥå
 */
Inline bool_t
primap_empty(void)
{
	return (ready_primap == 0U);
}

/*
 *  ꤷͥ٤ͥ٥ӥåȥޥåפåȤƤ뤫ɤΥå
 */
Inline bool_t
primap_test(uint_t pri)
{
	return ((ready_primap & PRIMAP_BIT(pri)) != 0U);
}

/*
 *  ͥ٥ӥåȥޥåפΥ
 */
Inline uint_t
primap_search(void)
{
	return bitmap_search((uint_t)ready_primap);
}

/*
 *  ͥ٥ӥåȥޥåפΥå
 */
Inline void
primap_set(uint_t pri)
{
	ready_primap |= PRIMAP_BIT(pri);
}

/*
 *  ͥ٥ӥåȥޥåפΥꥢ
 */
Inline void
primap_clear(uint_t pri)
{
	ready_primap &= ~PRIMAP_BIT(pri);
}

/*
 *  ǹ̥ͥΥ
 */

#ifdef TOPPERS_tsksched

uint_t
search_schedtsk(void)
{
	return primap_search();
}

#endif /* TOPPERS_tsksched */

/*
 * ꤷưͥ٤Υ¹ԤǤ֤ɤΥƥ
 *
 * ¹ԤǤtrue֤
 */
bool_t
test_dormant(uint_t ipri)
{
	return !primap_test(ipri);
}

/*
 *  ⥸塼ν
 */


#ifdef TOPPERS_tskini

void
initialize_task(void)
{
	/* ǥ塼Υӥåȥޥå׽ */
	ready_primap = init_rdypmap;
	
	/* ¹Իͥ٤ν */
	runtsk_ipri = IPRI_NULL;
	
	/* ߶ػߥե饰ν */
	disdsp = false;
}

#endif /* TOPPERS_tskini */

/*
 *  ipri : ưоݥεưͥ(ɽ)
 */

#ifdef TOPPERS_tskact

bool_t
make_active(uint_t ipri)
{
	bool_t dsp;
	
	primap_set(ipri);
	
	if(ipri < runtsk_ipri) {
		dsp = !disdsp;
	}
	else {
		dsp = false;
	}
	
	return dsp;
}

#endif /* TOPPERS_tskact */


/*
 *  apri : ¹Գϥεưͥ
 *  ƤӽФ CPUå
 */

#ifdef TOPPERS_tskrun

void
run_task(uint_t ipri)
{
	uint_t next_pri;	/* ˼¹ԳϤ륿εưͥ */
	uint_t saved_pri;	/* ƤӽФεưͥ */
	
	next_pri = ipri;
	saved_pri = runtsk_ipri;
	
	do {
		runtsk_ipri = tinib_epriority[next_pri];
		
		/* CPUå */
		t_unlock_cpu();
		
		/* ¹Գ */
		(*((TASK)(tinib_task[next_pri])))(tinib_exinf[next_pri]);
		
		if (t_sense_lock()) {
			/*
			 *  CPUå֤ext_tskƤФ줿ϡCPUå
			 *  Ƥ饿λ롥ϡӥǤCPU
			 *  åάФ褤
			 */
		}
		else {
			/*
			 *  t_lock_cpu򤳤βdisdspΤ褦ˤʤΤϡ
			 *  CPUå˺t_lock_cpuƤФʤǤ롥
			 */
			t_lock_cpu();
		}
		
		/* ͥ٥ޥ֤ΤϤʤΤǡ⤷ʤ */
		
		/*
		 *  ǥѥåػ߾֤ext_tskƤФ줿ϡǥѥ
		 *  ľ֤ˤƤ饿λ롥
		 *
		 *	ϰʲΤ褦˵Ҥ٤Ǥ뤬ˤdisdsp
		 *	falseˤФᡤñfalseꤹ롥
		 *
		 *		if (disdsp) {
		 *			disdsp = false;
		 *		}
		 */
		disdsp = false;
		
		/* ӥåȥޥåץꥢ */
		primap_clear(next_pri);
		
	  /* 西μ¹Իͥ٤⤤ưͥ٤ĥư줿 */
	} while((!primap_empty()) && (saved_pri > (next_pri = search_schedtsk())));
	
	runtsk_ipri = saved_pri;
}

#endif /* TOPPERS_tskrun */

/*
 *  δؿߥå֤Ʊξ֤ sta_ker ƤФ
 */

#ifdef TOPPERS_tsk_dsp

void
dispatcher(void)
{
	do {
		if(!primap_empty()) {
			/* γ */
			run_task(search_schedtsk());
		}
		else {
			idle_loop();
		}
	} while(true);
}

#endif /* TOPPERS_tsk_dsp */
