/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2010 by Meika Sugimoto
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 */
 
 /*
 *  TOPPERS/SSPΥץץ
 */

#include <kernel.h>
#include <sil.h>
#include "kernel_cfg.h"
#include "syssvc/serial.h"

#include "sample1.h"

/*
 *  
 */
#define LOGPUT(str)	\
	serial_wri_dat(SIO_PORTID , (const char_t *)(str) , sizeof(str)/sizeof((str)[0]))

#define TASKLOG(tskno , message , buf)		\
	do										\
	{										\
		LOGPUT("Task ");					\
		(buf)[0] = (tskno) + '0';			\
		LOGPUT(buf);						\
		LOGPUT(" " message ".\n");			\
	} while(0)

/*
 *  ƥॵӥΥ顼ϥɥ
 */
#define SVC(expression)			\
	if((expression) < 0)		\
	{							\
		LOGPUT("Error at : ");	\
		LOGPUT(__FILE__);		\
		LOGPUT(" caused by ");	\
		LOGPUT(#expression);	\
		LOGPUT(".\n");			\
	}

/*
 *  ¹Ԥ륿ؤΥåΰ
 */
char_t message[3];

/*
 *  롼ײ
 */
ulong_t	task_loop;		/* ǤΥ롼ײ */


void init_task(intptr_t exinf)
{
#ifndef TASK_LOOP
	volatile ulong_t	i;
	SYSTIM	stime1, stime2;
#endif /* TASK_LOOP */
	
	/* ꥢݡȤΥץ */
	SVC(serial_opn_por(SIO_PORTID));
	SVC(serial_ctl_por(SIO_PORTID , IOCTL_CRLF));
	
	/* ưåν */
	LOGPUT("Sample program starts.\n");
	
	/* ᥤ󥿥εư */
	SVC(act_tsk(MAIN_TASK));

	/*
 	 *  롼ײ
	 *
	 *  TASK_LOOPޥƤ硤¬ꤻˡTASK_LOOP
	 *  줿ͤ򡤥ǤΥ롼ײȤ롥
	 *
	 *  MEASURE_TWICEޥƤ硤1ܤ¬̤Τ
	 *  ơ2ܤ¬̤Ȥ1ܤ¬Ĺλ֤Ф뤿ᡥ
	 */
#ifdef TASK_LOOP
	task_loop = TASK_LOOP;
#else /* TASK_LOOP */

	task_loop = LOOP_REF;
	SVC(get_tim(&stime1));
	for (i = 0; i < task_loop; i++);
	SVC(get_tim(&stime2));
	task_loop = LOOP_REF * 400UL / (stime2 - stime1);

#endif /* TASK_LOOP */

}


void main_task(intptr_t exinf)
{
	static ID tskid = TASK1;
	static uint_t tskno = 1;
	char_t c;
	
	/* ꥢݡȤʸ */
	if(serial_rea_dat(SIO_PORTID , &c , 1) > 0)
	{
		switch(c)
		{
		case 'e':
		case 'z':
		case 'Z':
		case 'r':
			message[tskno] = c;
		    break;
		case '1':
			tskid = TASK1;
			tskno = 0;
			break;
		case '2':
			tskid = TASK2;
			tskno = 1;
			break;
		case '3':
			tskid = TASK3;
			tskno = 2;
			break;
		case 'a':
			SVC(act_tsk(tskid));
			break;
		case 'Q':
			LOGPUT("Sample program ends.\n");
			ext_ker();
			break;
		default:
			/* 顼ɽ */
			LOGPUT("Unknown command.\n");
			break;
		}
	}
}


void task(intptr_t exinf)
{
	/* exinfϥֹ  */
	uint_t tskno = (uint_t)exinf;
	char_t command;
	char_t buf[1];
	bool_t cont = true;
	const ID next_tskid[3] = { TASK2 , TASK3 , TASK1 };
	volatile ulong_t	i;
	
	TASKLOG(tskno , "activate" , buf);
	
	do
	{
		for (i = 0; i < task_loop; i++)
			;
		
		/* ֹɽ */
		TASKLOG(tskno , "running" , buf);
		
		/* ޥɼåΰ򥯥ꥢ */
		command = message[tskno - 1];
		message[tskno - 1] = 0;
		
		switch(command)
		{
		case 'e':
			cont = false;
			TASKLOG(tskno , "exit" , buf);
			break;
		case 'r':
			SVC(act_tsk(next_tskid[tskno - 1]));
			cont = false;
			break;
		case 'z':
			RAISE_CPU_EXCEPTION;
			break;
		default:
			break;
		}
	}while(cont == true);
}

void cyclic_handler(intptr_t exinf)
{
	ID tskid = (ID)exinf;
	
	SVC(iact_tsk(tskid));
}

#ifdef TEST_EXC
void exc_handler(void *p_excinf)
{
	LOGPUT("CPU exception handler.\n");
	ext_ker();
}
#endif /* TEST_EXC */

